---
title: Firefox 37 for developers
slug: Mozilla/Firefox/Releases/37
tags:
  - Firefox
  - Release Notes
---
<div>{{FirefoxSidebar}}</div><p>Firefox 37 was released on March 31st, 2015. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<p>Highlights:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Network_Monitor#Security">Security panel in the Network Monitor</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Work_with_animations#Firefox_37">Animations panel in the Page Inspector</a></li>
 <li><a href="/en-US/docs/Tools/WebIDE/Running_and_debugging_apps#Running_a_custom_build_step">Support for running a custom build step in WebIDE</a></li>
</ul>

<p><a class="external-icon external" href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;classification=Client%20Software&amp;chfieldto=2015-01-12&amp;chfield=resolution&amp;query_format=advanced&amp;chfieldfrom=2014-11-28&amp;chfieldvalue=FIXED&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;component=Developer%20Tools&amp;component=Developer%20Tools%3A%203D%20View&amp;component=Developer%20Tools%3A%20Canvas%20Debugger&amp;component=Developer%20Tools%3A%20Console&amp;component=Developer%20Tools%3A%20Debugger&amp;component=Developer%20Tools%3A%20Framework&amp;component=Developer%20Tools%3A%20Graphic%20Commandline%20and%20Toolbar&amp;component=Developer%20Tools%3A%20Inspector&amp;component=Developer%20Tools%3A%20Memory&amp;component=Developer%20Tools%3A%20Netmonitor&amp;component=Developer%20Tools%3A%20Object%20Inspector&amp;component=Developer%20Tools%3A%20Profiler&amp;component=Developer%20Tools%3A%20Responsive%20Mode&amp;component=Developer%20Tools%3A%20Scratchpad&amp;component=Developer%20Tools%3A%20Source%20Editor&amp;component=Developer%20Tools%3A%20Storage%20Inspector&amp;component=Developer%20Tools%3A%20Style%20Editor&amp;component=Developer%20Tools%3A%20Timeline&amp;component=Developer%20Tools%3A%20User%20Stories&amp;component=Developer%20Tools%3A%20Web%20Audio%20Editor&amp;component=Developer%20Tools%3A%20WebGL%20Shader%20Editor&amp;component=Developer%20Tools%3A%20WebIDE&amp;product=Firefox&amp;list_id=11892733">All devtools bugs fixed between Firefox 36 and Firefox 37</a>.</p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>{{cssxref("display")}}<code>:</code> <code>contents</code> is now activated by default ({{bug(1102374)}} and {{bug(1105369)}}).</li>
 <li><a href="/en-US/docs/Web/Guide/CSS/Using_multi-column_layouts">CSS multi-column layout</a> is now working on element with {{cssxref("display")}}<code>:</code> <code>table-caption</code> ({{bug(1109571)}}).</li>
 <li>Relative positioning ({{cssxref("position")}}<code>:</code> <code>relative</code>) of table cells has been implemented ({{bug(35168)}}).</li>
 <li>The quirks mode behavior of {{cssxref("empty-cells")}} has been removed: it now defaults to <code>show</code> like in standard mode ({{bug(1020400)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The value <code>&lt;a rel="noreferrer"&gt;</code> now also works when the link is opened in new tab ({{bug(1031264)}}).</li>
 <li>The <code>'.'</code> followed by the extension is now allowed in <code>&lt;input accept&gt;</code>: when used, a file selector filters with this given extension to be proposed to the user ({{bug(826176)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The {{jsxref("Map")}}, {{jsxref("Set")}}, {{jsxref("WeakMap")}} and {{jsxref("WeakSet")}} constructors now ignore null iterable ({{bug(1092538)}}).</li>
 <li>The {{jsxref("Map")}}, {{jsxref("Set")}}, {{jsxref("WeakMap")}} and {{jsxref("WeakSet")}} constructors now supports monkey-patched <code>prototype.set</code> or <code>prototype.add</code> ({{bug(804279)}}).</li>
 <li>The Non-standard {{jsxref("String.quote","String.prototype.quote()")}} method has been removed ({{bug(1103181)}}).</li>
 <li>The {{jsxref("RegExp.prototype.flags")}} property has been implemented ({{bug(1108467)}}).</li>
 <li>Several {{jsxref("Array")}} methods have been implemented for <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed arrays</a> as well:
  <ul>
   <li>The {{jsxref("TypedArray.every", "every()")}} and {{jsxref("TypedArray.some", "some()")}} methods ({{bug(1116390)}}).</li>
   <li>The {{jsxref("TypedArray.find", "find()")}} and {{jsxref("TypedArray.findIndex", "findIndex()")}} methods ({{bug(1078975)}}).</li>
   <li>The {{jsxref("TypedArray.fill", "fill()")}} method ({{bug(1113722)}}).</li>
   <li>The {{jsxref("TypedArray.indexOf", "indexOf()")}} and {{jsxref("TypedArray.lastIndexOf", "lastIndexOf()")}} methods ({{bug(1107601)}}).</li>
   <li>The {{jsxref("TypedArray.join", "join()")}} method ({{bug(1115817)}}).</li>
   <li>The {{jsxref("TypedArray.reduce", "reduce()")}} and {{jsxref("TypedArray.reduceRight", "reduceRight()")}} methods ({{bug(1117350)}}).</li>
   <li>The {{jsxref("TypedArray.reverse", "reverse()")}} method ({{bug(1111516)}}).</li>
   <li>The {{jsxref("TypedArray.keys", "keys()")}}, {{jsxref("TypedArray.values", "values()")}}, and {{jsxref("TypedArray.entries", "entries()")}} methods ({{bug(1119217)}}).</li>
  </ul>
 </li>
 <li>ES2015 Proxy {{jsxref("Global_Objects/Proxy/handler/enumerate", "enumerate")}} trap is implemented ({{bug(783829)}}).</li>
 <li>The <code>configurable</code> attribute of the {{jsxref("Function.length")}} property is now <code>true</code> per the ES2015 specification ({{bug(911142)}}).</li>
 <li>The development of <a href="http://wiki.ecmascript.org/doku.php?id=strawman:data_parallelism">ParallelJS (PJS)</a> has been discontinued due to the limited future prospects, little attention and code complexity. The experimental implementation that had been enabled only on the Nightly channel, including the <code>Array.prototype.mapPar</code>, <code>filterPar</code> and <code>reducePar</code> methods, has been completely removed.</li>
</ul>

<h3 id="InterfacesAPIsDOM">Interfaces/APIs/DOM</h3>

<ul>
 <li>The {{domxref("StereoPannerNode")}} <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio</a> node has been implemented ({{bug(1100349)}}).</li>
 <li>The {{jsxref("Promise")}}-based version of {{domxref("OfflineAudioContext")}} is now available ({{bug(1087944)}}).</li>
 <li>The experimental, not activated by default, implementation of <a href="/en-US/docs/Web/API/ServiceWorker_API">Service Workers</a> progresses: {{domxref("ServiceWorkerGlobalScope.update()")}} has been implemented {{bug(1065366)}}.</li>
 <li>The <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB API</a> can now be used in <a href="/en-US/docs/Web/API/Web_Workers_API">Web workers</a> ({{bug(701634)}}).</li>
 <li>Our experimental implementation of WebGL 2.0 is going forward!
  <ul>
   <li>The {{domxref("WebGL2RenderingContext.getBufferSubData()")}} method has been implemented to provide access to Buffer Objects ({{bug(1048731)}}).</li>
  </ul>
 </li>
 <li>In keeping with the evolving WebRTC specification, we have deprecated {{domxref("RTCIceServer.url")}} in favor of {{domxref("RTCIceServer.urls")}}, which lets you specify more than one URL for a given ICE server.</li>
 <li>Some key names of <code>KeyboardEvent.key</code> are changed for conforming <a href="https://dvcs.w3.org/hg/dom3events/raw-file/tip/html/DOM3Events-key.html">the latest DOM Level 3 Events spec</a>. See <a href="/en-US/docs/Web/API/KeyboardEvent.key#Key_values">the tables of <code>KeyboardEvent.key</code> values in MDN</a>. The green cells are new values. And purple values are still unstable. Be careful if you use them (meta bug for these changes is {{bug(900372)}}).</li>
 <li>The {{domxref("Console")}} interface is now working on {{domxref("ServiceWorker")}} and {{domxref("SharedWorker")}}. It was previously available but not working ({{bug(1058644)}}).</li>
 <li>The value of {{domxref("KeyboardEvent.key")}} was incorrectly being reported as <code>"RomanCharacters"</code> when the <kbd>英数</kbd> (<kbd>Eisu</kbd>) key was pressed. Now it correctly returns <code>"Eisu"</code>.</li>
</ul>

<h3 id="MathML">MathML</h3>

<p><em>No change.</em></p>

<h3 id="SVG">SVG</h3>

<ul>
 <li>SVG2's <code>&lt;marker orient="auto-start-reverse"&gt;</code> has been implemented ({{bug(1107584)}}).</li>
</ul>

<h3 id="AudioVideo">Audio/Video</h3>

<p><em>No change.</em></p>

<h2 id="Networking">Networking</h2>

<ul>
 <li>WebSockets now supports the <code>permessage</code> compression method, if the server does support it ({{bug(792831)}}).</li>
</ul>

<h2 id="Security">Security</h2>

<ul>
 <li>The usage of weak protocols or ciphers, like SSL 3.0 and RC4, are now logged in the console, to warn sites that are using it ({{bug(1092835)}}).</li>
 <li>The <a href="/en-US/docs/Web/Security/CSP">CSP</a> 1.1 <code>referrer</code> <a href="/en-US/docs/Web/Security/CSP/CSP_policy_directives">directive</a> is now supported ({{bug(965727)}}).</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="Add-on_SDK">Add-on SDK</h3>

<p><em>No change.</em></p>

<h3 id="XUL">XUL</h3>

<p><em>No change.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/37/">Site Compatibility for Firefox 37</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers('36')}}</p>
